%define atilibdir %{_libdir}/fglrx
%define atilib32dir %{_prefix}/lib/fglrx
%define desktop_vendor ati

%ifarch i386
    %define atiarch x86
%endif

%ifarch x86_64
    %define atiarch x86_64
    %define xext _64a
%endif

Name:            ati-x11-drv
Version:         8.59.2
Release:         1%{?dist}
Summary:         AMD's proprietary driver for ATI graphic cards
Group:           User Interface/X Hardware Support
License:         Redistributable, no modification permitted
URL:             http://www.ati.com/support/drivers/linux/radeon-linux.html
Source0:         http://www2.ati.com/drivers/linux/ati-driver-installer-9-3-x86.x86_64.run

# taken from the rpmforge dkms package
Source2:	ati.sh
Source3:	ati.csh
Source4:	ati-config-display
Source5:	ati.nodes

BuildRoot:       %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

ExclusiveArch:   x86_64 i386

# provides desktop-file-install
BuildRequires:	desktop-file-utils

Requires:	ati-kmod = %{?epoch:%{epoch}:}%{version}-%{release}
Requires(post):	ati-kmod = %{?epoch:%{epoch}:}%{version}-%{release}

Requires(post):  chkconfig
Requires(post):	/sbin/ldconfig

# for ati-config-display
Requires(post):	 pyxf86config
Requires(preun): pyxf86config

Requires(preun): chkconfig

Obsoletes:       %{name} < %{version}-%{release}
Provides:        %{name} = %{version}-%{release}

%description
This package provides the most recent proprietary AMD display driver which
allows for hardware accelerated rendering with ATI Mobility, FireGL and
Desktop GPUs. Some of the Desktop and Mobility GPUs supported are the
Radeon 9500 series to the Radeon HD 4800 series.

For the full product support list, please consult the release notes
for release %{version}.


%package devel
Summary:         Development files for %{name}
Group:           Development/Libraries
Requires:        %{name} = %{version}-%{release}

Obsoletes:       %{name}-devel < %{version}-%{release}
Provides:        %{name}-devel = %{version}-%{release}

%description devel
This package provides the development files of the %{name} package,
such as OpenGL headers.

%prep
%setup -q -c -T
sh %{SOURCE0} --extract .

# fix doc perms
find common/usr/share/doc/fglrx -type f -exec chmod 0644 {} \;

%build
# Nothing to build

%install
%{__rm} -rf %{buildroot}

# Install utilities, atieventsd program with its init script and man
%{__mkdir_p} %{buildroot}{%{_bindir},%{_sbindir},%{_sysconfdir}/ati}
%{__install} -p -m 0755 arch/%{atiarch}/usr/X11R6/bin/* \
                        common/usr/X11R6/bin/* \
    %{buildroot}%{_bindir}/
%{__install} -p -m 0755 arch/%{atiarch}/usr/sbin/* \
                        common/usr/sbin/* \
    %{buildroot}%{_sbindir}/
%{__install} -D -p -m 0755 packages/Fedora/atieventsd.init \
    %{buildroot}%{_sysconfdir}/rc.d/init.d/atieventsd
%{__install} -p -m 0644 common/etc/ati/* \
    %{buildroot}%{_sysconfdir}/ati/
%{__chmod} 755 %{buildroot}%{_sysconfdir}/ati/authatieventsd.sh
%{__install} -D -p -m 0644 common/usr/share/man/man8/atieventsd.8 \
    %{buildroot}%{_mandir}/man8/atieventsd.8
%{__install} -D -p -m 0755 %{SOURCE4} \
    %{buildroot}%{_sbindir}/

# Install libraries
%{__mkdir_p} %{buildroot}%{atilibdir}
%{__install} -p -m 0755 arch/%{atiarch}/usr/X11R6/%{_lib}/*.* \
                        arch/%{atiarch}/usr/%{_lib}/*.* \
    %{buildroot}%{atilibdir}
%ifarch x86_64
    %{__mkdir_p} %{buildroot}%{atilib32dir}
    %{__install} -p -m 0755 arch/x86/usr/X11R6/lib/*.* \
                            arch/x86/usr/lib/*.* \
        %{buildroot}%{atilib32dir}
%endif

# Driver modules
%{__mkdir_p} %{buildroot}%{_libdir}/xorg/modules/{drivers,linux}
%{__install} -p -m 0755 x710%{?xext}/usr/X11R6/%{_lib}/modules/drivers/* \
    %{buildroot}%{_libdir}/xorg/modules/drivers/
%{__install} -p -m 0755 x710%{?xext}/usr/X11R6/%{_lib}/modules/linux/* \
    %{buildroot}%{_libdir}/xorg/modules/linux/
%{__install} -p -m 0755 x710%{?xext}/usr/X11R6/%{_lib}/modules/*.* \
    %{buildroot}%{_libdir}/xorg/modules/

# Install dri and extensions
%{__mkdir_p} %{buildroot}%{_libdir}/dri/
%{__install} -p -m 0755 arch/%{atiarch}/usr/X11R6/%{_lib}/modules/dri/* \
    %{buildroot}%{_libdir}/dri/
%ifarch x86_64
    %{__mkdir_p} %{buildroot}%{_prefix}/lib/dri/
    %{__install} -p -m 0755 arch/x86/usr/X11R6/lib/modules/dri/* \
        %{buildroot}%{_prefix}/lib/dri/
%endif
%{__mkdir_p} %{buildroot}%{_libdir}/xorg/modules/extensions/fglrx
%{__install} -p -m 0755 x710%{?xext}/usr/X11R6/%{_lib}/modules/extensions/* \
    %{buildroot}%{_libdir}/xorg/modules/extensions/fglrx/

# Install header files and sample
%{__mkdir_p} %{buildroot}%{_includedir}/GL
%{__install} -p -m 0644 common/usr/include/GL/*.h \
    %{buildroot}%{_includedir}/GL/
%{__mkdir_p} %{buildroot}%{_includedir}/X11/extensions
%{__install} -p -m 0644 common/usr/X11R6/include/X11/extensions/*.h \
    %{buildroot}%{_includedir}/X11/extensions/
%{__install} -D -p -m 0644 common%{_usrsrc}/ati/fglrx_sample_source.tgz \
    %{buildroot}%{_usrsrc}/ati/fglrx_sample_source.tgz

# Install doc and icons
%{__mkdir_p} %{buildroot}%{_datadir}/doc
%{__cp} -a common%{_datadir}/doc/fglrx %{buildroot}%{_datadir}/doc
%{__rm} -rf %{buildroot}%{_datadir}/doc/fglrx/examples/
%{__mkdir_p} %{buildroot}%{_datadir}/icons
%{__install} -p -m 0644 common%{_datadir}/icons/* \
    %{buildroot}%{_datadir}/icons

# Install ACPI config and scripts
%{__install} -D -p -m 0644 packages/Fedora/a-ac-aticonfig \
    %{buildroot}%{_sysconfdir}/acpi/events/ac-aticonfig
%{__install} -p -m 0644 packages/Fedora/a-lid-aticonfig \
    %{buildroot}%{_sysconfdir}/acpi/events/lid-aticonfig
%{__install} -D -p -m 0755 packages/Fedora/ati-powermode.sh \
    %{buildroot}%{_sysconfdir}/acpi/actions/ati-powermode.sh

# Install ld.so.conf.d file
%{__mkdir_p} %{buildroot}%{_sysconfdir}/ld.so.conf.d/
echo %{atilibdir} >    %{buildroot}%{_sysconfdir}/ld.so.conf.d/ati.conf.disable
%ifarch x86_64
    echo %{atilib32dir} >> %{buildroot}%{_sysconfdir}/ld.so.conf.d/ati.conf.disable
%endif

# Simlink libs
pushd %{buildroot}%{atilibdir}/
%{__ln_s} libGL.so.1.2 %{buildroot}%{atilibdir}/libGL.so.1
%{__ln_s} libGL.so.1 %{buildroot}%{atilibdir}/libGL.so
popd
%ifarch x86_64
    pushd %{buildroot}%{atilib32dir}/
    %{__ln_s} libGL.so.1.2 %{buildroot}%{atilib32dir}/libGL.so.1
    %{__ln_s} libGL.so.1 %{buildroot}%{atilib32dir}/libGL.so
    popd
%endif


# Install profile.d files
%{__install} -D -p -m 0644 %{SOURCE2} \
    %{buildroot}%{_sysconfdir}/profile.d/ati.sh
%{__install} -p -m 0644 %{SOURCE3} \
    %{buildroot}%{_sysconfdir}/profile.d/ati.csh

# Desktop entry
%{__mkdir_p} %{buildroot}%{_datadir}/applications
sed -i 's/=0/=false/' packages/Ubuntu/dists/source/amdcccle.desktop
desktop-file-install --vendor %{desktop_vendor} \
    --dir %{buildroot}%{_datadir}/applications \
    --remove-category=Utility \
    --add-category=SystemSetup \
    packages/Ubuntu/dists/source/amdcccle.desktop

# Control panel files
%{__mkdir_p} %{buildroot}%{_datadir}/ati/amdcccle
%{__install} -p -m 0644 common%{_datadir}/ati/amdcccle/* \
    %{buildroot}%{_datadir}/ati/amdcccle

# Set the correct path for gdm's Xauth file
sed -i 's|GDM_AUTH_FILE=/var/lib/gdm/$1.Xauth|GDM_AUTH_FILE=/var/gdm/$1.Xauth|' %{buildroot}%{_sysconfdir}/ati/authatieventsd.sh

# Install udev configuration file
%{__install} -D -p -m 0644 %{SOURCE5} \
    %{buildroot}%{_sysconfdir}/udev/makedev.d/60-ati.nodes

%clean
rm -rf %{buildroot}

%post
# Enable the proprietary driver
%{_sbindir}/ati-config-display enable || :
# Add init script
if [ "${1}" -eq 1 ]; then
  /sbin/chkconfig --add atieventsd ||:
fi ||:

%preun
# Disable the proprietary driver
%{_sbindir}/ati-config-display disable || :
# Remove init script
if [ "${1}" -eq 0 ]; then
  /sbin/chkconfig --del atieventsd ||:
fi ||:

%files
%defattr(-,root,root,-)
%doc %{_datadir}/doc/fglrx
%{_sysconfdir}/udev/makedev.d/60-ati.nodes
%dir %{_sysconfdir}/ati
%{_sysconfdir}/ati/authatieventsd.sh
%{_sysconfdir}/ati/signature
%config %{_sysconfdir}/ati/atiogl.xml
%config %{_sysconfdir}/ati/logo.xbm.example
%config %{_sysconfdir}/ati/logo_mask.xbm.example
%config %{_sysconfdir}/ati/control
%config %{_sysconfdir}/ati/amdpcsdb.default
%config %{_sysconfdir}/ld.so.conf.d/ati.conf.disable
%{_sysconfdir}/acpi/actions/ati-powermode.sh
%config(noreplace) %{_sysconfdir}/acpi/events/*aticonfig
%config(noreplace) %{_sysconfdir}/profile.d/ati.*
%{_initrddir}/*
%{_sbindir}/*
%{_bindir}/*
%{_libdir}/xorg/modules/drivers/fglrx_drv.so
%{_libdir}/xorg/modules/linux/libfglrxdrm.so
%{_datadir}/applications/*amdcccle.desktop
%{_datadir}/ati
%{_datadir}/icons/*.xpm
%{_mandir}/man[1-9]/atieventsd.*
%{_libdir}/xorg/modules/extensions/fglrx
%{_libdir}/xorg/modules/*.so
%{atilibdir}/*.so*
%{atilibdir}/libAMDXvBA.cap
%{_libdir}/dri/fglrx_dri.so
%ifarch x86_64
    %{atilib32dir}/*.so*
    %{atilib32dir}/libAMDXvBA.cap
    %{_prefix}/lib/dri/fglrx_dri.so
%endif

%files devel
%defattr(-,root,root,-)
%doc %{_usr}/src/ati/fglrx_sample_source.tgz
%{atilibdir}/*.a
%ifarch x86_64
  %{atilib32dir}/*.a
%endif
%{_libdir}/xorg/modules/*.a
%{_includedir}/GL/*.h
%{_includedir}/X11/extensions/*.h

%changelog

* Wed Aug 12 2009 Marco Giunta <marco.giunta AT sissa DOT it>
- Initial RPM release.
