# Define the kmod package name here.
%define  kmod_name ati

Name:    %{kmod_name}-kmod
Version: 8.59.2
Release: 1%{?dist}
Group:   System Environment/Kernel
License: Redistributable, no modification permitted
Summary: AMD display driver kernel module
URL:     http://ati.amd.com/support/drivers/linux/linux-radeon.html

BuildRoot:     %{_tmppath}/%{name}-%{version}-%{release}-build-%(%{__id_u} -n)
ExclusiveArch: i686 x86_64

# Sources.
Source0: http://www2.ati.com/drivers/linux/ati-driver-installer-9-3-x86.x86_64.run
Source10: kmodtool-%{kmod_name}

NoSource: 0

# If kversion isn't defined on the rpmbuild line, build for the current kernel.
%{!?kversion: %define kversion %(uname -r)}

# Define the variants for each architecture.
%define basevar ""
%ifarch i686
%define paevar PAE
%endif
%ifarch i686 x86_64
%define xenvar xen
%endif

# If kvariants isn't defined on the rpmbuild line, build all variants for this architecture.
%{!?kvariants: %define kvariants %{?basevar} %{?xenvar} %{?paevar}}

# Magic hidden here.
%define kmodtool sh %{SOURCE10}
%{expand:%(%{kmodtool} rpmtemplate_kmp %{kmod_name} %{kversion} %{kvariants} 2>/dev/null)}

%description
The fglrx %{version} display driver kernel module.

%prep
%setup -q -c -T

sh %{SOURCE0} --extract fglrxpkg
for kvariant in %{kvariants} ; do
    %{__mkdir} -p _kmod_build_${kvariant}/lib
    %ifarch %{ix86}
        %{__cp} -ar fglrxpkg/common/lib/* fglrxpkg/arch/x86/lib/* _kmod_build_${kvariant}/lib
    %endif
    %ifarch x86_64
        %{__cp} -ar fglrxpkg/common/lib/* fglrxpkg/arch/x86_64/lib/* _kmod_build_${kvariant}/lib
    %endif
done

%build
for kvariant in %{kvariants} ; do
    ksrc=%{_usrsrc}/kernels/%{kversion}${kvariant:+-$kvariant}-%{_target_cpu}
    pushd _kmod_build_${kvariant}/lib/modules/fglrx/build_mod/2.6.x
    %{__make} CC="gcc" \
        LIBIP_PREFIX="%{_builddir}/%{buildsubdir}/_kmod_build_${kvariant}/lib/modules/fglrx/build_mod/" \
        MODFLAGS="-DMODULE -DATI -DFGL" \
        KVER="%{kversion}${kvariant:+-$kvariant}-%{_target_cpu}" \
        KDIR="${ksrc}"
    popd
done

%install
%{__rm} -rf ${RPM_BUILD_ROOT}
for kvariant in %{kvariants} ; do
    %{__install} -D -m 0755 _kmod_build_${kvariant}/lib/modules/fglrx/build_mod/2.6.x/fglrx.ko %{buildroot}/lib/modules/%{kversion}${kvariant}/extra/%{kmod_name}/fglrx.ko
done

# Strip the module(s).
find %{buildroot} -type f -name \*.ko -exec %{__strip} --strip-debug \{\} \;

%clean
%{__rm} -rf %{buildroot}

%changelog
* Wed Aug 12 2009 Marco Giunta <marco.giunta AT sissa DOT it>
- Initial build of the kmod packages.
- Source file is included in ati-x11-drv.
